//******************************************
//           This is a C Template file
//ߣ   
//     
//
//ע
//******************************************

//******************************************
//Stack Pointer	=	0x23f (If use mq6822_32PinPackage_startup.asm)
//Ram range = 0x40~0x23f
//******************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif  
#include "MQ6822.h"
 
#include "iApp.h"
#include "OPmode.h"
#include "KWU.h"
#include "ExtINT.h"

//-- ض庯 --//


//-- 庯 --//


//-- ȫֱ --//


//-- ȫֳ --//


//-- ȫֱ --//




void main()
{
//----------------------------------------------------------------------//
//****** IO, CGCR ʼ P10/P40/P41 ڷʱ֮趨 ****************//
//----------------------------------------------------------------------//
	SYSTEM_INIT();		// IO, CGCR ʼ P10/P40/P41 ڷʱ֮趨
//----------------------------------------------------------------------//
	WDCDR.byte = 0x4e;				// clear wdt

//--------------------------------------------------------------------------------------------------//
//	Ҫ (ⲿپ or ⲿپ),  <OPmode.h> 趨£
//.....................................................................................
//#undef	XTAL_High		// ⲿپ: #define(ʹþ) / #undef(þ) :
//#undef	XTAL_Low		// ⲿپ: #define(ʹþ) / #undef(þ) :
//.....................................................................................
//	 <OPmode.h> ęnϳ
//	עļ֮ⲿл.
//--------------------------------------------------------------------------------------------------//




//*********************************************************************
// 			: Each Mode Switch Sequence
//	Normal1	:----------------------------------------------------------
//			: --> Normal1
//			: --> IDLE0(INTTBT release)		--> Normal1
//			: --> IDLE1(Interrupt release)	--> Normal1
//			: --> STOP (ȴ)			--> Normal1
//	Normal2	:----------------------------------------------------------
//			: --> Normal2
//			: --> IDLE2(ȴж)			--> Normal2
//			: --> STOP (ȴ)			--> Normal2
//	SLOW2	:----------------------------------------------------------
//			: --> SLOW2
//	SLOW1	:----------------------------------------------------------
//			: --> SLOW1
//			: --> SLEEP0(INTTBT release)	--> SLOW1
//			: --> SLEEP1(Interrupt release)	--> SLOW1
//			: --> STOP  (ȴ)			--> SLOW1
//	--------:----------------------------------------------------------
//*********************************************************************


//----------------------------------------//
//	˷ KWI5  STOP mode
	d_KWU_05_EnL;
//......|..| EnL/EnH/Dis: stop mode release level, or Disable
//......| 00~15: KWU00~KWU15

//----------------------------------------//
//****** Power on Ϊ Normal1 mode ******//
//----------------------------------------//

//	Normal1 entry stop mode ............
	__asm("CPL (_P8DR).3");
	Active_STOP;					// ˷ KWI5  STOP mode
	__asm("CPL (_P8DR).3");

//	Normal1 entry IDLE0 mode ............
	__asm("CPL (_P8DR).2");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_IDLE0;					// TGHALT: (Normal1->IDLE0) / (SLOW1->SLEEP0) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P8DR).2");

//	Normal1 entry IDLE1 mode ............
	__asm("CPL (_P9DR).1");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_IDLE1;					// IDLE: (Normal1->IDLE1) / (Normal2->IDLE2) / (SLOW1->SLEEP1) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P9DR).1");

//----------------------------------------//
//****** Entry Normal2 mode **************//
//----------------------------------------//
//	MQ6822 LIRC һϵΪ״̬
//	Ա change to Normal2 mode, ϵͳɲԤ reset
	OpMode_Change_to(iNor2);		// ѡҪĹģʽ (iNor1/iNor2/iSlow2/iSlow1) ֮һ

//	Normal2 entry stop mode ............
	__asm("CPL (_P8DR).3");
	Active_STOP;					// ˷ KWI5  STOP mode
	__asm("CPL (_P8DR).3");

//	Normal2 entry IDLE2 mode ............
	__asm("CPL (_P9DR).1");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_IDLE2;					// IDLE: (Normal1->IDLE1) / (Normal2->IDLE2) / (SLOW1->SLEEP1) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P9DR).1");

//----------------------------------------//
//****** Entry SLOW2 mode ****************//
//----------------------------------------//
	OpMode_Change_to(iSlow2);		// ѡҪĹģʽ (iNor1/iNor2/iSlow2/iSlow1) ֮һ

//----------------------------------------//
//****** Entry SLOW1 mode ****************//
//----------------------------------------//
	OpMode_Change_to(iSlow1);		// ѡҪĹģʽ (iNor1/iNor2/iSlow2/iSlow1) ֮һ

//	SLOW1 entry stop mode ............
	__asm("CPL (_P8DR).3");
	Active_STOP;					// ˷ KWI5  STOP mode
	__asm("CPL (_P8DR).3");

//	SLOW1 entry SLEEP0 mode ............
	__asm("CPL (_P8DR).2");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_SLEEP0;					// TGHALT: (Normal1->IDLE0) / (SLOW1->SLEEP0) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P8DR).2");

//	SLOW1 entry SLEEP1 mode ............
	__asm("CPL (_P9DR).1");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_SLEEP1;					// IDLE: (Normal1->IDLE1) / (Normal2->IDLE2) / (SLOW1->SLEEP1) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P9DR).1");
//----------------------------------------//
//----------------------------------------//


	WDCDR.byte = 0x4e;				// clear wdt
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	while(1)
	{
		WDCDR.byte = 0x4e;			// clear wdt

	}
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

}


