//******************************************
//           This is a C Template file
//ߣ   
//     
//
//ע
//****************************************** 
//******************************************
//Stack Pointer	=	0x23f (If use mq6822_x_startup.asm)
//Ram range = 0x40~0x23f
//******************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif  
#include "MQ6822.h"
 

void main()
{
    /**********   
     setting TCA timer   
	   
	**********/

	P7CR.bit.b2 = 0;

	__asm("DI");
	POFFCR0.byte = 0x1;
	EIRH.bit.b6 = 1;
	__asm("EI");
	TA0CR.byte = 0xC2; //enable overflow interrupt,TFF=1,no noise canceller,enable auto capture
	TA0MOD.byte = 0x84; //double buffer,source clk=fcgck/2^10,external trigger mode
	TA0DRAL.byte = 0x21;
	TA0DRAH.byte = 0x0;  //setting counting register limit = 0x0021
	TA0CR.bit.b0 = 1;	//start Timer Counter
	while(1)
	{
		WDCDR.byte= 0x4e;	//clear WDT
		
	} 
	
}